package fr.edf.distribution.brms.jit.test;

import java.util.concurrent.TimeUnit;

import org.drools.core.time.impl.PseudoClockScheduler;
import org.junit.Test;
import org.kie.api.KieBase;
import org.kie.api.runtime.KieSession;

import fr.edf.distribution.brms.issue.model.DummyEvent;

public class ExpiredEventsTest extends AbstractCommonTest {

	private static final String DRL = "package fr.edf.distribution.brms.common.test\n" +
			"import fr.edf.distribution.brms.issue.model.DummyEvent\n" +
			"import fr.edf.distribution.brms.issue.model.OtherDummyEvent\n" +
			"declare DummyEvent\n" +
			"@role( event )\n" +
			"@expires( 3d )\n" +
			"@timestamp( eventTimestamp )\n" +
			"@propertyReactive\n" +
			"end\n" +
			"declare OtherDummyEvent\n" +
			"@role( event )\n" +
			"@expires( 3d )\n" +
			"@timestamp( eventTimestamp )\n" +
			"@propertyReactive\n" +
			"end\n" +
			"rule \"RG_TEST_1\"\n" +
			"    when\n" +
			"       $event: DummyEvent ()\n" +
			"       not OtherDummyEvent (id == $event.id, this after[0, 48h] $event)\n" +
			"    then\n" +
			"        retract($event);\n" +
			"end";

	@Test
	public void testRemoveExpiredEvent() throws Exception {

		System.setProperty("drools.dialect.mvel.strict", "false");

		KieBase kieBase = newKieBase(DRL);
		KieSession kieSession = newSession(kieBase);

		long now = System.currentTimeMillis();

		PseudoClockScheduler sessionClock = kieSession.getSessionClock();
		sessionClock.setStartupTime(now);

		kieSession.insert(new DummyEvent("dummy"));
		sessionClock.advanceTime(3, TimeUnit.DAYS);

		kieSession.fireAllRules();
	}
}